unit BTRVView;  {   ࠡ  BTrieve 䠩 }
{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}

interface

uses Crt, Objects, Views, Drivers, Dos, LongView, B_Interf, busimesg, BtrvMess;

{==================================================}
Type
 { ᨢ  । ⠢  THead 室 ⮢}
  PHeadArray = ^THeadArray;
  { ᯮ㥬 ப 易⥫쭮   묨 !!!! }
  THeadArray = array[0..4] of String;

  { THead }

  PHead = ^THead;
  THead = Object(TLScroller)
   High         : integer;
   HeadArray    : PHeadArray; { ᨢ     }
   Constructor Init(var Bounds: TRect; AHScrollBar:PLScrollBar;
                        anArray :PHeadArray; aSize:word);
   Procedure ChangeArray(AHeadArray :PHeadArray);
   Procedure Draw; Virtual;
  End;

   { TRecordBox }

   PRecordBox = ^TRecordBox;
   TRecordBox = Object
                 Pos  : LongInt;         {BTRV }
                 Body : Pointer;         {㪠⥫   ࠧ SIZE}
                 Constructor Init(Size : Integer);
              End;

  { TLineCol }

  PLineCol = ^TLineCol;
  TLineCol = object( TCollection)
    Rec_Len :  Integer;
    Constructor Init(ALimit, ADelta, ARec_Len : Integer);
    procedure   FreeItem(P: Pointer); virtual;
  end;

  { TFileBrowRec }

  PFileBrowRec = ^TFileBrowRec;
  TFileBrowRec = record
    RecInBuf   : word;    { ⢮ ᥩ   }
    Co_st      : longint; { 饥 ⢮ ᥩ  䠩 }
    PosInFile  : longint; {  砫   䠩 (c 0) }
    PrevPos    : longint; { ।  砫   䠩 (c 0) }
  end;

{   TBtrFileV  }

  PBtrFileV = ^TBtrFileV;
  TBtrFileV = object(TLScroller)
    BrFile     : B_PFile; {   䠩 }
    Browser    : TFileBrowRec;
    IsValid    : Boolean;
    Image      : byte;      {  ࠭ ।⠢ ,
                               GetText}
    Selecting  : Boolean;   {  ० ᥫ஢ ?}
    BegSelected: longint;   { 砫쭠 न ᥫ㥬 }
    EndSelected: longint;   { 筠 न ᥫ㥬 }
    BegSelP    : pointer;   { 砫쭠 Position ᥫ㥬 }
    EndSelP    : Pointer;   { 筠 Position ᥫ㥬 }
    FileLines  : PLineCol;  {  }
    Temp       : boolean;   { 뫮   뫮 ࢮ ⥭  GetEnyLine }
    FocusedAt  : Longint;   {  ⥪饩  }
    Focused    : Pointer;   { BTRV position   ன ⮨  }
    FocusedInBuf : pointer;  {⥫    Focused}
    CaseForm   : Word;
    Private
   {}
    DeltPrev    : longint;   { । Delta }
    BufferKBSize: longint;  {  ࠭祭    
                                 ====    ?==== }
    PrintBuf    : Pointer;      {******}
    PUBLIC
   {}
    constructor Init(  var Bounds: TRect;
                           AHScrollBar, AVScrollBar: PLScrollBar;
                           ABufferKBSize : word;
                           AMaxWidth      : integer;
                                        {   筮 ।⠢ }
                           APfile   : b_PFile;
                           Direct   : Boolean );  {冷 뢠}

    Procedure  HandleEvent(var Event: TEvent); virtual;
    Procedure  FocuseChanged;virtual;{뢠   䮪}

    destructor Done; virtual;

    procedure  Draw; virtual;


    function DeleteRecord: Boolean;{४뢠}

    procedure UpDateRecord; virtual;    {४뢠}

    procedure UpDateFocused(pp : pointer); virtual;    {४뢠}

    function  EditRecord(var Rec) : Boolean; virtual; {४뢠}

    function InsertRecord(var Rec): Boolean;  {४뢠}

    procedure  ReadInBuffer(Direction : integer); virtual; {
        Direction = 0   ࠢ
             1 C 砫 䠩
             2   䠩
             3     N- ப  ।饬 
             4      N- ப  ।饬 
             }
    procedure  ReReadBuffer; virtual;

    function   Valid(Command: Word): Boolean; virtual;

    procedure  ScrollDraw; Virtual;

    procedure  SetMaxLimit(AMaxWidth: integer); Virtual;
                  {   筮 ।⠢}
    Function   SetVarLen : Word;  Virtual;  {뢠, ᫨ 
               ६    ।  (㬮砭 16 K)}
    Function   BtrvMessError(Err : Integer ):Word;
                                           {   BTRV 訡}
    Function   GetText(IndBuf : LongInt): String;
    { 뢠  Draw }
    Function   FormatRec(p : Pointer; ACaseForm : Word):String; virtual;
    { 뢠  GetText}            {४뢠}
    Procedure  ClearBox(p : Pointer);

    Function   InsertRelation(p : word):boolean;

    Function   DeleteRelation(p : word):boolean;

    Function   AddRelation(p : word):boolean;

    Function   GetEnyLine( GetType: Boolean; var res : word): Pointer; Virtual;
    { ᫨ GetType True - 砥  , False - ᫥.
      ᫨  뤥  㦭   ,  ࢮ
      ⠥  砫 뤥,  ࢠ ப 䠩.
       Res 頥 訡 }
    Function   GetPrintLine(Var p:Pointer):Word; Virtual;  {**T****}

    Function   GetPrintStr(Var S:String):Word; Virtual; {**T****}

    Function   GetFocusedLine: Pointer; Virtual;
    { ࠦ 㪠⥫  TRecordBox  室 襭  }
    Procedure  CheckBufer; { ஢ઠ - 㦭 뢠    }

    Function FillBuffer( Direction : boolean):boolean;
    {  㦥 ⠢       }
    Private
   {}
    Procedure  SetFocused; {-- ⠭ Focused
      -  ⮤ 뢠  Draw.
    ஬ Draw   ४뢠 !  --}

    Procedure  InitBuffer; {᫨    㤠 
                               ᮧ }
    Procedure  SetSelected( Home : Boolean);
               {-- ⠭ Selected  砫 - True   - False }
    Procedure  SetSelecting( Yes: boolean);
               {-- ⠭ Selected State - True,  - False}
  end;
{ TBtrFileW }
  PBtrFileW = ^TBtrFileW;
  TBtrFileW = object(TLWindow)
    FileView : PBtrFileV;
    HeadView : PHead;
    constructor Init(FileName: PathStr;
                     ABufferKBSize  : word;  {    }
                     AMaxWidth      : integer;
                     APfile         : b_PFile;
                     AHeadArray     : PHeadArray; { ⠢塞  }
                     Direct         : Boolean );  {冷 뢠}
    procedure InsertBTRVViewer(
                     ABufferKBSize  : word;  {    }
                     AMaxWidth      : integer;
                     APfile         : b_PFile;
                     AHeadArray     : PHeadArray; { ⠢塞  }
                     Direct         : Boolean ); virtual;
                     {冷 뢠}
    procedure InsertCurrentHead( AHeadArray : PHeadArray);virtual;
    procedure SetCompatibleRect; virtual;
  end;

const
  RBtrFileVie: TStreamRec = (
     ObjType: 10290;
     VmtLink: Ofs(TypeOf(TBtrFileV)^);
     Load:    @TBtrFileV.Load;
     Store:   @TBtrFileV.Store
  );
  RBtrFileW: TStreamRec = (
     ObjType: 10291;
     VmtLink: Ofs(TypeOf(TBtrFileW)^);
     Load:    @TBtrFileW.Load;
     Store:   @TBtrFileW.Store
  );

procedure RegisterFBtrV;

implementation

uses Memory, MsgBox, App, Dialogs, Tur5btrv;
{======================== TLineCol ========================}
Constructor TLineCol.Init(ALimit, ADelta, ARec_Len : Integer);
Begin
  TCollection.Init(ALimit, ADelta);
  Rec_Len := ARec_Len;
End;
{========================================================================}
procedure TLineCol.FreeItem( P: Pointer);
begin
  FreeMem(pRecordBox(P)^.Body,Rec_Len);
  Dispose(pRecordBox(p));
end;
{================== TRecordBox =================================}
Constructor TRecordBox.Init(Size : Integer);
Begin
  pos:=0;
  body:=nil;
  GetMem(Body,Size);
End;
{=========================================================================}
Procedure ToZString(S:String; var SF); { ८ ப  Z-ப }
Type
  B = Array[1..256] of Byte;
Begin
  Move(S[1],SF,Length(S));
  B(SF)[Length(S)+1]:=0;
End;
{================== TBtrFileV =================================}
Const
   MaxCountWait  = 5; {⢮ ⮪ ७  }
   Delay_Open    = 500;
   Delay_Command = 100;
{=====================================================================}
constructor TBtrFileV.Init(  var Bounds: TRect;
                           AHScrollBar, AVScrollBar: PLScrollBar;
                           ABufferKBSize : word;
                           AMaxWidth      : integer;
                                        {   筮 ।⠢ }
                           APfile   : b_PFile;
                           Direct   : Boolean );  {冷 뢠}
var
  Line     : string;
  MaxWidth : integer;
  Err      : B_Error;
begin
  CaseForm := 0;
  IsValid := False;
  TLScroller.Init(Bounds, AHScrollbar, AVScrollBar);
  GrowMode := gfGrowHiX + gfGrowHiY;
  if APFile = nil then begin
     BtrvMessError(3);
     exit;
  end;
  BrFile := APFile;
  Image :=0;
  Temp:=false;
  FocusedAt:=0;
  Focused:=nil;
  FocusedInBuf:=nil;
  With Browser Do Begin
    RecInBuf := 0;             { ⢮ ᥩ   }
    Co_st    := 0;             { 饥 ⢮ ᥩ  䠩 }
    PosInFile:= 0;             {  砫   䠩 }
    PrevPos  := 0;
  End;
  Err :=BrFile^.b_Main_Stat;
  if Err <> Success then begin
      BtrvMessError(Error);
      exit;
  end;
  {ࢨ筠 ⠭ ࠧ   ࠭祭}
  BufferKBSize:=ABufferKBSize;
  if memavail < (BufferKBSize * 1024) + 20*1024 then  begin
     BufferKBSize := (memavail div 1024) - 20;
  end;
  if BufferKBSize <= 0 then exit;
  MaxWidth:=(((BrFile^.Rec_Len div 16 )+1) * 16) +
       (((SizeOf(TRecordBox) div 16 )+1) * 16) ;
  {  뢠  ᠬ 쥪.     ࠣ }
  Browser.co_st:=BrFile^.KeyCo_St[BrFile^.Num_Key];
  if Browser.co_st = -1 then begin
   MessageBox(^C'࠭  e ࠢ.',nil,mfError+mfOkButton);
   Exit;
  end;
  if Browser.co_st = -2 then begin
   MessageBox(^C' ⢮ ᥩ  .',nil,mfError+mfOkButton);
   Exit;
  end;
  SetLimit(AMaxWidth, Browser.co_st);
  ShowCursor;
{  MaxWidth:=((MaxWidth div 16 )+1) * 16;      ࠣ }
  Browser.RecInBuf := (BufferKBSize*1024) div MaxWidth;
  Browser.RecInBuf := Browser.RecInBuf-1-((Browser.RecInBuf*4+200) div MaxWidth);
  If Browser.RecInBuf <= 5 then exit;
  If Browser.RecInBuf >= 16300 then Browser.RecInBuf:=16300;
  Selecting := False;
  BegSelected := -10;
  EndSelected := -10;
  BegSelP:=nil;
  EndSelP:=nil;
  DeltPrev:=0;
  ReadInBuffer(1);
  isValid:=True;
end;
{==========================================================================}
destructor TBtrFileV.Done;
begin
  if FileLines<>nil then begin
     Dispose(FileLines, Done);
     FileLines:=nil;
  end;
  inherited Done;
end;
{=========================================================================}
function TBtrFileV.Valid(Command: Word): Boolean;
begin
  Valid := IsValid;
end;
{=========================================================================}
Procedure  TBtrFileV.InitBuffer; {᫨    㤠 
                               ᮧ }
begin
  if FileLines<>nil then begin
     Dispose(FileLines, Done);
     FileLines:=nil;
  end;
  FileLines := New(PLineCol, Init(Browser.RecInBuf,5,BrFile^.Rec_Len));
end;
{=========================================================================}
procedure TBtrFileV.ScrollDraw;
var
  D: TLPoint;
begin
  if HScrollBar <> nil then D.X := HScrollBar^.Value
  else D.X := 0;
  if VScrollBar <> nil then D.Y := VScrollBar^.Value
  else D.Y := 0;
  if (D.X <> Delta.X) or (D.Y <> Delta.Y) then
  begin
    Delta := D;
    {if DrawLock <> 0 then DrawFlag := True else}
    DrawView;
  end;
end;
{=========================================================================}
Function  TBtrFileV.FillBuffer( Direction : boolean):boolean;
var
  err        : b_error;
  P          : PRecordBox;
BEGIN
   FillBuffer:=false;
         err:=success;
         while (err=success) and (FileLines^.Count < Browser.RecInBuf) do  begin
            P:=New(PRecordBox,Init(BrFile^.Rec_Len));
            if Direction then err:=BrFile^.b_Get_Prev(P^.Body^)
            else err:=BrFile^.b_Get_Next(P^.Body^);
            if (err <> success) then begin
               ClearBox(P);
               if (Err=End_File) then Break;
               RemBW;
               exit;
            end;
            err:=brfile^.b_Get_Position(Pointer(P^.Pos));
            if Direction then FileLines^.AtInsert(0,P)
            else FileLines^.Insert(P);
         end;
   FillBuffer:=true;
end;
{=========================================================================}
procedure TBtrFileV.ReadInBuffer(Direction : integer);
 var
  j          : longint;      {ᯮ  稪   BTRV Position }
  err        : b_error;
  P          : PRecordBox;
  CurrentPoint,               { ﭨ  PosInBuf   PrevPos}
  LimitPoint ,                { ﭨ  PosInBuf   Limit.Y}
  BeginPoint : longint;       { ﭨ  0  PosInBuf }
  Up         : boolean; { 㤠   䠩 (True)  (False) }

begin
  PutBW;
  if Limit.y <= 0 then begin
    RemBW;
    exit;
  end;
   case Direction of
   0 : begin            {     PosInFile }
               { 塞   窨  }
         j:=0;
         CurrentPoint:=Browser.PosInFile - Browser.PrevPos;
         LimitPoint  :=Limit.Y - Browser.PosInFile;
         BeginPoint  :=Browser.PosInFile;
                 {  砫 䠩 }
         If (BeginPoint <= abs(CurrentPoint)) and
                                    (BeginPoint <= LimitPoint) then begin
              P:=New(PRecordBox,Init(BrFile^.Rec_Len));
              Up:=False;
              err:=brFile^.b_Get_First(P^.Body^);
              if err <> success then begin
                 BtrvMessError(Error);
                 RemBW;
                 exit;
              end;
              inc(j);
              while ((err = success) and (j < Browser.PosInFile-1)) do begin
                err:=BrFile^.B_Get_Next(P^.Body^);
                inc(j);
              end;
              ClearBox(P);
         end;
                      {  ।饩 窨 䠩 }
         If (abs(CurrentPoint) < LimitPoint) and
                        (abs(CurrentPoint) < BeginPoint) then begin
              if CurrentPoint < 0 then  begin
                     Up:=True;
                     P := FileLines^.At(0);
              end
              else begin
                     Up:=False;
                     P := FileLines^.At(FileLines^.Count-1);
              end;
              j:=P^.Pos;
              P:=New(PRecordBox,Init(BrFile^.Rec_Len));
              err:=brFile^.b_Get_Direct(Pointer(j), P^.Body^);
              if err <> success then begin
                 BtrvMessError(Error);
                 RemBw;
                 exit;
              end;

              if Up then j:=Browser.PrevPos
              else       j:=Browser.PrevPos + Browser.RecInBuf;

              if Up then
                while ((err = success) and
                     (j > Browser.PosInFile + Browser.RecInBuf)) do begin
                  err:=BrFile^.B_Get_Prev(P^.Body^);
                  dec(j);
                end
              else
                while ((err = success) and (j < Browser.PosInFile)) do begin
                  err:=BrFile^.B_Get_Next(P^.Body^);
                  inc(j);
                end;
              ClearBox(P);
         end;
                      {   䠩 }
         If (LimitPoint <= abs(CurrentPoint)) and
                        (LimitPoint < BeginPoint) then begin
              P:=New(PRecordBox,Init(BrFile^.Rec_Len));
              Up:=True;
              j:=Limit.Y;
              err:=brFile^.b_Get_Last(P^.Body^);
              if err <> success then begin
                 BtrvMessError(Error);
                 RemBW;
                 exit;
              end;
              dec(j);
              while ((err = success) and
                       (j > Browser.PosInFile + Browser.RecInBuf-1)) do begin
                err:=BrFile^.B_Get_Prev(P^.Body^);
                dec(j);
              end;
              ClearBox(P);
         end;

         InitBuffer;
       end;
   1 :begin         {   砫 䠩 }
         Up:=False;
         InitBuffer;
         P:=New(PRecordBox,Init(BrFile^.Rec_Len));
         err:=brFile^.b_Get_First(P^.Body^);
         if err <> success then begin
            BtrvMessError(Error);
            RemBW;
            exit;
         end;
         err:=brfile^.b_Get_Position(Pointer(P^.Pos));
         FileLines^.Insert(P);
      end;
   2 :begin         {    䠩 }
         Up:=True;
         InitBuffer;
                 {  ந  ⭮ 浪 }
         P:=New(PRecordBox,Init(BrFile^.Rec_Len));
         err:=brFile^.b_Get_Last(P^.Body^);
         if err <> success then begin
            BtrvMessError(Error);
            RemBW;
            exit;
         end;
         err:=brfile^.b_Get_Position(Pointer(P^.Pos));
         FileLines^.AtInsert(0,P);
      end;
   3 : begin   {      N- ப  ।饬  }
         Up:=True;
         P := FileLines^.At(integer(Size.Y-1));
         j:=P^.pos;
         InitBuffer;
                  {  ந  ⭮ 浪 }
         P:=New(PRecordBox,Init(BrFile^.Rec_Len));
         err:=brFile^.b_Get_Direct(Pointer(j), P^.Body^);
         if err <> success then begin
            BtrvMessError(Error);
            RemBW;
            exit;
         end;
         err:=brfile^.b_Get_Position(Pointer(P^.Pos));
         FileLines^.AtInsert(0,P);
       end;
   4 : begin   {       N- ப  ।饬  }
         Up:=False;
         P := FileLines^.At(integer(FileLines^.Count-Size.Y));
         j:=P^.pos;
         InitBuffer;
                   {  ந  אַ 浪 }
         P:=New(PRecordBox,Init(BrFile^.Rec_Len));
         err:=brFile^.b_Get_Direct(Pointer(j), P^.Body^);
         if err <> success then begin
            BtrvMessError(Error);
            RemBW;
            exit;
         end;
         err:=brfile^.b_Get_Position(Pointer(P^.Pos));
         FileLines^.Insert(P);
       end;
   else;{case}
   end;{case}
 if fillbuffer(up) then RemBW;
 Browser.PrevPos:=Browser.PosInFile;
end;
{=========================================================================}
procedure TBtrFileV.ReReadBuffer;
 var
  j          : longint;      {ᯮ  稪   BTRV Position }
  err        : b_error;
  P          : PRecordBox;

begin
 PutBW;
 if (Limit.y <= 0) then begin
  RemBW;
  exit;
 end;

 if (FileLines^.Count = 0) or (FileLines = nil) or (Limit.Y <= Browser.RecInBuf) then begin
   {,     ,   .}
  Delta.Y := 0;
  ScrollTo(Delta.X,Delta.Y);
  ReadInBuffer(1);
  RemBW;
  DrawView;
  Exit;
 end;

 if (Browser.PosInFile = Browser.PrevPos)  then
      j := TRecordBox(FileLines^.At(0)^).Pos;

 InitBuffer;

 P:=New(PRecordBox,Init(BrFile^.Rec_Len));
 err := BrFile^.b_Get_Direct(Pointer(j),P^.Body^);
 if err <> Success then begin
  BtrvMessError(Error);
  RemBW;
  Exit;
 end;
 P^.Pos:=j;
 FileLines^.Insert(P);

 if FillBuffer(false) then RemBW;
 Browser.PrevPos:=Browser.PosInFile;
end;

{=========================================================================}
Procedure TBtrFileV.CheckBufer;
begin

  browser.PrevPos:=browser.PosInFile;

  if  (Delta.Y = 0) then  begin
      if browser.PosInFile <> 0 then begin
         Browser.PosInFile:=0;            {    砫 䠩 }
         ReadInBuffer(1);
      end;
      exit;
  end;

  if (abs(Delta.Y - DeltPrev) > Browser.RecInBuf) then begin
     if (Delta.Y < Browser.RecInBuf-Size.Y) then begin
        Browser.PosInFile:=0;
        ReadInBuffer(1);
        exit;
     end;
     if (Delta.Y < Browser.co_st-Browser.RecInBuf) then begin
        Browser.PosInFile:=Delta.Y-Size.Y;
        if Browser.PosInFile < 0 then Browser.PosInFile:= 0;
        ReadInBuffer(0);
        exit;
     end
     else begin
        Browser.PosInFile:=Browser.co_st-Browser.RecInBuf;
        if Browser.PosInFile < 0 then Browser.PosInFile:= 0;
        ReadInBuffer(2);
        exit;
     end;
   end;

  if  Delta.Y < Browser.PosInFile then  begin {    砫 䠩}
      Browser.PosInFile:=Browser.PosinFile-(Browser.RecInBuf-Size.Y);
      if  Browser.PosInFile<0  then  begin  {    砫 䠩 }
          Browser.PosInFile:=0;
          ReadInBuffer(1);
          exit;
      end;
      ReadInBuffer(3);
      exit;
  end;
                              {      䠩 }
  if ( Delta.Y > (Browser.PosInFile+FileLines^.Count-Size.Y))
     or ( Delta.Y = (Browser.co_st-Size.y)) then  begin
      If  Delta.Y = (Browser.co_st-Size.y) then begin
                {     䠩 }
          if Browser.PosInFile <> Browser.co_st-Browser.RecInBuf then begin
            Browser.PosInFile:=Browser.co_st-Browser.RecInBuf;
            if Browser.PosInFile < 0 then Browser.PosInFile:=0;
            ReadInBuffer(2);
          end;
          exit;
      end
      else  begin
         Browser.PosInFile:=Browser.PosinFile+FileLines^.Count-Size.Y;
         if  Browser.PosInFile > Browser.co_st  then  begin
                   {     䠩 }
             if Browser.PosInFile <> Browser.co_st-Browser.RecInBuf then begin
               Browser.PosInFile:=Browser.Co_St-Browser.RecInBuf;
               ReadInBuffer(2);
             end;
             exit;
         end;
         ReadInBuffer(4);
         exit;
      end;
      if Browser.PosInFile < 0  then begin
                Browser.PosInFile:=0;  {    砫 䠩 }
                ReadInBuffer(1);
                exit;
      end;
      ReadInBuffer(4);
  end;
end;
{-------------------------- ४뢠  ---------------------------}
procedure TBtrFileV.Draw;
var
  B:  TDrawBuffer;
  NormalColor,
  SelectedColor,
  FocusedColor : Word;
  I:  Integer;
  j:  longint;
  S:  String;
  P:  PString;
begin
  NormalColor := GetColor(1);
  FocusedColor:= GetColor(3);
  SelectedColor:= GetColor(4);
  if Delta.Y <> DeltPrev  then  begin
     CheckBufer;
     DeltPrev := Delta.Y;
    end;
  SetFocused;
           {  ᮢ 饣 ࠭ }
  for I := 0 to Size.Y - 1 do
  begin
    J := Delta.Y + I;
    if ((J >= BegSelected) and (J <= EndSelected)) or
       ((J <= BegSelected) and (J >= EndSelected))
     then MoveChar(B, ' ', SelectedColor, Size.X)
     else MoveChar(B, ' ', NormalColor, Size.X);
    if i = ((FocusedAt-1)-Delta.Y) then
               MoveChar(B, ' ', FocusedColor, Size.X);
    if Delta.Y + I < Browser.co_st then  { - ப}
    begin
      s:='';
      if ((Delta.Y-Browser.PosInFile) + i) <= FileLines^.Count-1 then
                       s := GetText(integer((Delta.Y-Browser.PosInFile) + i));
        {  ப !!!}
      if  byte(s[0]) <> 0 then S := Copy(s, Delta.X + 1, Size.X);

    if ((J >= BegSelected) and (J <= EndSelected)) or
       ((J <= BegSelected) and (J >= EndSelected))
       then MoveStr(B, S, SelectedColor)
       else MoveStr(B, S, NormalColor);
    if i = ((FocusedAt-1)-Delta.Y) then
               MoveStr(B, S, FocusedColor);
    end;
     WriteBuf(0, I, Size.X, 1, B);
  end;
end;
{=========================================================================}
Function  TBtrFileV.GetPrintStr(Var S:String):Word;
Var
  Res : Word;
  p   : Pointer;
Begin
  Res := GetPrintLine(p);
  GetPrintStr := Res;
  S := '';
  If (Res = 0) or (Res = 5) Then S:=  FormatRec(p,CaseForm);
End;
{=========================================================================}
Function  TBtrFileV.GetPrintLine(Var p:Pointer):Word;
Var
  Res : Word;
Begin
  If PrintBuf <> Nil Then ClearBox(PrintBuf);
  PrintBuf := GetEnyLine(Not Temp,res);
  If Not( (Res = 0) or (Res = 5)) Then
    Begin
      PrintBuf := Nil;
      p        := Nil;
    End
  Else
    P := pRecordBox(PrintBuf)^.Body;
  GetPrintLine := Res;
End;
{=========================================================================}
Function TBtrFileV.GetText(IndBuf : LongInt): String;
Var
  p : Pointer;
Begin
  P := pRecordBox(FileLines^.At(IndBuf))^.Body;
  GetText := FormatRec(p,CaseForm);
End;
{=========================================================================}
Function TBtrFileV.FormatRec(p : Pointer; ACaseForm : Word):String;
Begin
 Abstract;
End;
{=========================================================================}
Function  TBtrFileV.BtrvMessError(Err : Integer):Word;
            {   BTRV 訡}
Begin
 ErrorBtrv(Err);
End;
{=========================================================================}
Procedure  TBtrFileV.SetMaxLimit(AMaxWidth : integer);
             {⠭   筮 ।⠢ }
var err: b_error;
begin
  Err :=BrFile^.b_Main_Stat;
  if Err <> Success then begin
      BtrvMessError(Error);
      exit;
  end;
  {ࢨ筠 ⠭ ࠧ   ࠭祭}
  Browser.co_st:=BrFile^.KeyCo_St[BrFile^.Num_Key];
  SetLimit(AMaxWidth,Browser.co_st);
end;
{=========================================================================}
Procedure  TBtrFileV.SetFocused;
var CurP : Pointer; { ⥫  ⥪    }
begin
  if FileLines^.Count <> 0 then begin
   FocusedAt:=Delta.Y + Cursor.Y+1;
   CurP:=FileLines^.At(integer((Delta.Y + Cursor.Y)-Browser.PosInFile));
   FocusedInBuf:=CurP;
   Focused:=Pointer(PRecordBox(CurP)^.Pos);
  end;
end;
{========================================================================}
Procedure  tBtrFileV.ClearBox(p : Pointer);
Begin
  FreeMem(pRecordBox(P)^.Body,Brfile^.Rec_Len);
  Dispose(pRecordBox(p));
  p:=Nil;
End;
{========================================================================}
Function   TBtrFileV.GetEnyLine( GetType: Boolean; var res : word): Pointer;
    { ᫨ GetType True - 砥  , False - ᫥.
      ᫨  뤥  㦭   ,  ࢮ
      ⠥  砫 뤥,  ࢠ ப 䠩
      Res = 0  Ok
          = 1 ⪠  ᫥  稢 
          = 2  䠩
          = 3  襭 Temp
          = 4 訡 BTrieve
          = 5  
          = 6 㣠 訡 }
var
   CurP : Pointer;
   P    : PRecordBox;
   err  : B_Error;
begin
  GetEnyLine:=nil;
  res:=0;
  if GetType then begin
    if BegSelected<>-10 then begin
             P:=New(PRecordBox,Init(BrFile^.Rec_Len));
             if BegSelected = EndSelected then CurP:=BegSelP
             else if BegSelected < EndSelected  then CurP:=BegSelP
             else CurP:=EndSelP;
             err:=brFile^.b_Get_Direct(CurP,P^.Body^);
             if (err <> success) and (err<>End_file) then begin
                res:=4;
                ClearBox(p);
                exit;
             end;
             err:=brfile^.b_Get_Position(Pointer(P^.Pos));
            if err = End_File then res:=2;
            if BegSelected = EndSelected then res:=5;
    end
    else  begin
            P:=New(PRecordBox,Init(BrFile^.Rec_Len));
            err:=brFile^.b_Get_First(P^.Body^);
            if (err <> success) and (err<>End_file)  then begin
               res:=4;
               FreeMem(pRecordBox(P)^.Body,BrFile^.Rec_Len);
               Dispose(pRecordBox(p));
               exit;
            end;
            if err = End_File then res:=2;
            err:=brfile^.b_Get_Position(Pointer(P^.Pos));
    end;
    temp:=true;
  end
  else  begin
          if not temp then begin
             res:=1;
             exit;
          end;
          P:=New(PRecordBox,Init(BrFile^.Rec_Len));
          err:=brFile^.b_Get_Next(P^.Body^);
          if (err <> success) and (err<>End_file) then begin
             res:=4;
             FreeMem(pRecordBox(P)^.Body,BrFile^.Rec_Len);
             Dispose(pRecordBox(p));
             exit;
          end;
          if err = End_File then res:=2;
          err:=brfile^.b_Get_Position(Pointer(P^.Pos));
          if (begSelected<>-10) and
             ((Pointer(P^.Pos)=BegSelP) or (Pointer(P^.Pos)=EndSelP)) then
             begin
             temp:=not temp;
             res:=5;
          end;
  end;
  GetEnyLine:=p;
end;
{========================================================================}
Function   TBtrFileV.GetFocusedLine: Pointer;
    { ࠦ 㪠⥫  TRecordBox  室 襭  }
var
   CurP : pointer;
begin
   CurP:=FileLines^.At(integer(FocusedAt-Browser.PosInFile-1));
   GetFocusedLine:=PRecordBox(CurP)^.Body;
end;
{=========================================================================}
Function TBtrFileV.SetVarLen : Word;
Begin
  SetVarLen := 16*1024;
End;
{=========================================================================}
      {-- ⠭ Selected State - True,  - False}
Procedure  TBtrFileV.SetSelecting( Yes: boolean);
begin
  if limit.y = 0 then Yes:=False;
  if Yes Then Selecting:=True
         Else begin
           Selecting:=False;
           BegSelected := -10;
           EndSelected := -10;
           BegSelP := nil;
           EndSelP := nil;
         end;
End;
{=========================================================================}
       {-- ⠭ Selected  砫 - True   - False }
Procedure  TBtrFileV.SetSelected( Home: Boolean);
var CurP : pointer;
begin
  if limit.y = 0 then exit;
  if Home then  begin
            SetSelecting(True);
            BegSelected := Delta.Y + Cursor.Y;
            EndSelected := BegSelected;
            CurP:=FileLines^.At(integer(BegSelected-Browser.PosInFile));
            BegSelP:=Pointer(PRecordBox(CurP)^.Pos);
  end
  else begin
    CurP:=FileLines^.At(integer(EndSelected-Browser.PosInFile));
    EndSelP:=Pointer(PRecordBox(CurP)^.Pos);
    Selecting:=False;
  end;
end;
{=========================================================================}
Function   TBtrFileV.InsertRelation(p : word):boolean;
begin
  Abstract;
end;
{=========================================================================}
Function   TBtrFileV.DeleteRelation(p : word):boolean;
begin
  Abstract;
end;
{=========================================================================}
Function   TBtrFileV.AddRelation(p : word):boolean;
begin
  Abstract;
end;
{=========================================================================}
function TBtrFileV.DeleteRecord: Boolean;  {   }
var P     : PRecordBox;
    Event : TEvent;
    Res : word;
begin
 DeleteRecord:= FALSE;
 P:=PRecordBox(FocusedInBuf);

 brFile^.b_Lock(True);
 Res := cmOk;
 repeat
  brFile^.b_Get_Direct(Focused,P^.Body^);
  case Error of
   84: begin
        Res := MessageBox(^C'  .'#13#13^C'஡㥬  ࠧ?',nil,mfOKCancel);
        if Res = cmCancel then begin
         brFile^.b_Lock(False);
         Exit;
        end;
       end;
    0: begin
        Break;
       end;
   else begin
         BtrvMessError(Error);
         brFile^.b_Lock(False);
         Exit;
        end;
  end;
 until (Res = cmCancel);

 if BrFile^.b_Delete <> Success then begin
  BtrvMessError(Error);
  brFile^.b_Lock(False);
  Exit;
 end;

 if brFile^.b_UnLock <> Success then begin
  BtrvMessError(Error);
  brFile^.b_Lock(False);
  Exit;
 end;
 brFile^.b_Lock(False);

 DeleteRecord:= TRUE;

 if (FileLines^.Count - 1 > 0) then
  if (FocusedInBuf = FileLines^.At(FileLines^.Count-1)) then begin
   Event.What := evKeyDown;
   Event.KeyCode := kbUp;
   HandleEvent(Event);
  end;
 FileLines^.Delete(P);
 ClearBox(P);
 SetLimit(Limit.X,Limit.Y-1);
 PBtrFileW(Owner)^.SetCompatibleRect;
 Owner^.Redraw;
end;
{=========================================================================}
function TBtrFileV.InsertRecord(var Rec): Boolean;
begin
 InsertRecord:= FALSE;
 if BrFile^.b_Insert(Rec) <> Success then begin
  BtrvMessError(Error);
  Exit;
 end;
 InsertRecord:= TRUE;
 SetLimit(Limit.X,Limit.Y+1);
 Browser.Co_St := Limit.Y;
 ReReadBuffer;
 PBtrFileW(Owner)^.SetCompatibleRect;
end;
{=========================================================================}
function TBtrFileV.EditRecord(var Rec) : Boolean;
begin
 abstract;
end;
{=========================================================================}
procedure TBtrFileV.UpDateRecord;  {   }
var P   : PRecordBox;
    Res : word;
begin
 P:=PRecordBox(FocusedInBuf);
 brFile^.b_Lock(True);
 Res := cmOk;
 repeat
  brFile^.b_Get_Direct(Focused,P^.Body^);
  case Error of
   84: begin
        Res := MessageBox(^C'  .'#13#13^C'஡㥬  ࠧ?',nil,mfOKCancel);
        if Res = cmCancel then begin
         brFile^.b_Lock(False);
         Exit;
        end;
       end;
    0: begin
        Break;
       end;
   else begin
         BtrvMessError(Error);
         brFile^.b_Lock(False);
         Exit;
        end;
  end;
 until (Res = cmCancel);

 if EditRecord(P^.Body^) then
  if BrFile^.b_UpDate(P^.Body^) <> Success then begin
   BtrvMessError(Error);
   brFile^.b_Lock(False);
   Exit;
  end;

 if brFile^.b_UnLock <> Success then begin
  BtrvMessError(Error);
  brFile^.b_Lock(False);
  Exit;
 end;

 brFile^.b_Lock(False);
 DrawView;
end;
{=========================================================================}
procedure TBtrFileV.UpDateFocused( pp : pointer);
var P   : PRecordBox;
    Res : word;
begin
 P:=PRecordBox(FocusedInBuf);
 brFile^.b_Lock(True);
 Res := cmOk;
 repeat
  brFile^.b_Get_Direct(Focused,P^.Body^);
  case Error of
   84: begin
        Res := MessageBox(^C'  .'#13#13^C'஡㥬  ࠧ?',nil,mfOKCancel);
        if Res = cmCancel then begin
         brFile^.b_Lock(False);
         Exit;
        end;
       end;
    0: begin
        Break;
       end;
   else begin
         BtrvMessError(Error);
         brFile^.b_Lock(False);
         Exit;
        end;
  end;
 until (Res = cmCancel);

  move(PP^,P^.Body^,FileLines^.Rec_Len);
  if BrFile^.b_UpDate(P^.Body^) <> Success then begin
   BtrvMessError(Error);
   brFile^.b_Lock(False);
   Exit;
  end;

 if brFile^.b_UnLock <> Success then begin
  BtrvMessError(Error);
  brFile^.b_Lock(False);
  Exit;
 end;

 brFile^.b_Lock(False);
 DrawView;
end;
{=========================================================================}
Procedure  TBtrFileV.FocuseChanged;
begin
end;

Procedure TBtrFileV.HandleEvent(var Event: TEvent);
  var CursorLoc : TPoint;

begin

if (Event.What = evMouseDown) then begin
   MakeLocal(Event.Where,CursorLoc);
   SetCursor(CursorLoc.X,CursorLoc.Y);
   FocuseChanged;
   DrawView;
   ClearEvent(Event);
 end;

if (Event.What = evBroadcast) and (Event.Command = cmScrollBarChanged) then begin
  ScrollDraw;
(*  ClearEvent(Event);*)
  Exit;
end;

if (Event.What = evKeyBoard) then
begin
 CursorLoc:=Cursor;
 case Event.KeyCode of
  kbF7:    Begin
            SetSelected(True);
            DrawView;
           end;
  kbF8:    SetSelected(False);
  kbF9:    Begin
            SetSelecting(False);
            DrawView;
           end;
     kbUp: begin
            if CursorLoc.Y > 0  then SetCursor(CursorLoc.X,CursorLoc.Y-1)
             else if Delta.Y > 0  then  begin
                           Delta.Y:=Delta.Y-1;
                           ScrollTo(Delta.X,Delta.Y);
                          end;
             if Selecting then EndSelected := Delta.Y + Cursor.Y;
             FocuseChanged;
             DrawView;
           end;
   kbDown:  begin
          if (CursorLoc.Y < Size.Y-1) and
                        (CursorLoc.Y+Delta.Y + 1 < Limit.Y) then
                                         SetCursor(CursorLoc.X,CursorLoc.Y+1)
              else if CursorLoc.Y+Delta.Y + 1 < Limit.Y  then  begin
                            Delta.Y:=Delta.Y+1;
                            ScrollTo(Delta.X,Delta.Y);
                           end;
             if Selecting then EndSelected := Delta.Y + Cursor.Y;
             FocuseChanged;
             DrawView;
            end;
   kbLeft: if CursorLoc.X > 0  then SetCursor(CursorLoc.X-1,CursorLoc.Y)
             else  if Delta.X > 0 then  begin
                     Delta.X := Delta.X - 1;
                     ScrollTo(Delta.X, Delta.Y);
                     DrawView;
                 end;
  kbRight: if CursorLoc.X < Size.X-1
             then SetCursor(CursorLoc.X+1,CursorLoc.Y)
             else  begin
               if (Delta.X + Size.X + 1) < Limit.X
                then Delta.X := Delta.X + 1
                else Delta.X := Limit.X - Size.X;
                ScrollTo(Delta.X,Delta.Y);
                DrawView;
              end;
  kbHome : begin
             SetCursor(0,CursorLoc.Y);
             Delta.X:=0;
             ScrollTo(Delta.X,Delta.Y);
             FocuseChanged;
             DrawView;
           end;
  kbEnd  : begin
             SetCursor(Size.X-1,CursorLoc.Y);
             Delta.X:=Limit.X - Size.X;
             ScrollTo(Delta.X,Delta.Y);
             FocuseChanged;
             DrawView;
           end;
 kbPgDn  : begin
            if Delta.Y+Size.Y <= Limit.Y  then begin
               Delta.Y := Delta.Y+Size.Y;
               if (Limit.y - delta.y) < Size.Y then begin
                 {Delta.Y := delta.y-( Size.Y-(Limit.Y-Delta.Y));}
                 Delta.Y := Limit.Y - Size.Y;  { 業! ன ᪮  ।饩 ப!!!!!!!!!!!!!!!!!!!!!!!!!!!! }
                 If Delta.Y < 0 Then Delta.Y := 0;
               end;
             end
             else  begin
               Delta.Y := Limit.Y-Size.Y;
               If Delta.Y < 0 Then Delta.Y := 0;
              end;
              ScrollTo(Delta.X,Delta.Y);
              if (Size.Y < Limit.Y-Delta.Y - 1)
               then CursorLoc.Y := Size.Y-1
               else CursorLoc.Y := limit.Y-Delta.Y-1;
            SetCursor(CursorLoc.X,CursorLoc.Y);
            if Selecting then EndSelected := Delta.Y + Cursor.Y;
            FocuseChanged;
            DrawView;
           end;
 kbPgUp  : begin
             if CursorLoc.Y > Size.Y - 1  then CursorLoc.Y:= Size.Y - 1;
               if Delta.Y-Size.Y >= 0  then Delta.Y:=Delta.Y-Size.Y
               else  begin
                   Delta.Y:=0;
                   CursorLoc.Y := 0;
                 end;
             SetCursor(CursorLoc.X,CursorLoc.Y);
             ScrollTo(Delta.X,Delta.Y);
             if Selecting then EndSelected := Delta.Y + Cursor.Y;
             FocuseChanged;
             DrawView;
           end;
kbCtrlPgUp: begin
              SetCursor(CursorLoc.X,0);
              Delta.Y:=0;
              ScrollTo(Delta.X,Delta.Y);
              if Selecting then EndSelected := Delta.Y + Cursor.Y;
              FocuseChanged;
              DrawView;
            end;
kbCtrlPgDn: begin
              Delta.Y:=Limit.Y-Size.Y;
              if Delta.Y < 0 then Delta.Y:=0;
              ScrollTo(Delta.X,Delta.Y);
              if Size.Y < Limit.Y then SetCursor(0,Size.Y - 1)
              else
                SetCursor(CursorLoc.X,Limit.Y - Delta.Y - 1 );
              if Selecting then EndSelected := Delta.Y + Cursor.Y;
              FocuseChanged;
              DrawView;
           end;
kbCtrlLeft: begin
             if Cursor.X - 20 >= 0  then SetCursor(Cursor.X - 20,Cursor.Y)
              else  begin
                if Delta.X - 20 >= 0  then Delta.X:= Delta.X - 20
                 else  begin
                   Delta.X:= 0;
                   SetCursor(0,Cursor.Y);
                  end;
                ScrollTo(Delta.X, Delta.Y);
               end;
             DrawView;
            end;
kbCtrlRight: begin
              if Cursor.X < Size.X - 21
                       then SetCursor(Cursor.X + 20,Cursor.Y)
               else  begin
                 if Delta.X + 20 + Size.X < Limit.X
                  then Delta.X := Delta.X + 20
                  else  begin
                    Delta.X := Limit.X - Size.X;
                    SetCursor(Size.X - 1,Cursor.Y);
                   end;
                ScrollTo(Delta.X, Delta.Y);
                end;
              DrawView;
             end;
 end;
  ClearEvent(Event);
end;
   TLScroller.HandleEvent(Event);
end;
{--------------------------- THead --------------------------------------}

Constructor THead.Init(VAR Bounds: TRect; AHScrollBar:PLScrollBar;
                        anArray:PHeadArray; aSize:word);
Begin
  Inherited Init(Bounds,AHScrollBar,NIL);
  Options  := Options and NOT ofSelectable;
  GrowMode := gfGrowHiX;
  HeadArray:= anArray;
  high     := Bounds.B.Y - Bounds.A.Y ;
  SetLimit(aSize,0);
End;
{-----------------------------------------------------------------}
Procedure THead.ChangeArray(AHeadArray :PHeadArray);
var
  i,
  HeadHigh,
  HeadSize   : word;
begin
  HeadHigh:=0;
  HeadSize:=0;
  while AHeadArray^[HeadHigh] <> '' do  begin
    I:=byte(AHeadArray^[HeadHigh][0]);
    if i > HeadSize then  HeadSize:=i;
    inc(HeadHigh);
  end;
  SetLimit(HeadSize,0);
  High:=HeadHigh-1;
  HeadArray:= AHeadArray;
end;
{-----------------------------------------------------------------}
Procedure THead.Draw;
var
  Color: Byte;
  I: byte;
  B: TDrawBuffer;
begin
  Color := GetColor(1);
  for i := 0 to Size.Y  do
  begin
   MoveChar(B, ' ', Color, Size.X);
	 MoveStr(B, Copy(HeadArray^[i], Delta.X+1, Size.X), Color);
	 WriteLine(0, i, Size.X, 1, B);
  end;
End;
{=========================== TBtrFileW ==================================}
constructor TBtrFileW.Init(FileName: PathStr;
                 ABufferKBSize  : word;  {    }
                 AMaxWidth      : integer;
                 APfile         : b_PFile;
                 AHeadArray     : PHeadArray; { ⠢塞  }
                 Direct         : Boolean );  {冷 뢠}
const
  WinNumber: Integer = 0;
var
  R: TRect;
begin
  Desktop^.GetExtent(R);
  inherited Init(R, FileName, 0);
  Options := Options or ofTileable;
  Palette:=wpBlueWindow;
  HeadView:=nil;
  FileView:=nil;
  InsertBTRVViewer(ABufferKBSize, AMaxWidth, APfile, AHeadArray, Direct);
  if AHeadArray <> nil then InsertCurrentHead(AHeadArray);
  SetCompatibleRect;
end;
{=========================================================================}
procedure TBtrFileW.InsertCurrentHead(AHeadArray : PHeadArray);
var
  R: TRect;
  i,
  HeadHigh,
  HeadSize   : word;

begin
  if HeadView <> nil then begin
     Delete(HeadView);
     Dispose(HeadView,Done);
     HeadView:=nil;
  end;
  GetExtent(R);
  R.Grow(-1, -1);
  HeadHigh:=0;
  HeadSize:=0;
  while (AHeadArray^[HeadHigh] <> '') and (HeadHigh <= 4) do  begin
    I:=byte(AHeadArray^[HeadHigh][0]);
    if i > HeadSize then  HeadSize:=i;
    inc(HeadHigh);
  end;
  R.B.Y:=HeadHigh+1;
  HeadView := New(PHead, Init(R,FileView^.HScrollBar,
    AHeadArray,HeadSize));
  Insert(HeadView);
  R.A.Y:=R.B.Y;
  R.B.Y:=Size.Y-1;
  FileView^.ChangeBounds(R);
end;
{=========================================================================}
procedure TBtrFileW.InsertBTRVViewer(
                     ABufferKBSize  : word;  {    }
                     AMaxWidth      : integer;
                     APfile         : b_PFile;
                     AHeadArray     : PHeadArray;
                     Direct         : Boolean );
                     {冷 뢠}
var
  R: TRect;
begin
  GetExtent(R);
  R.Grow(-1, -1);
  FileView := New(PBtrFileV, Init(R,
    StandardScrollBar(sbHorizontal + sbHandleKeyboard),
    StandardScrollBar(sbVertical + sbHandleKeyboard),
    ABufferKBSize, AMaxWidth, APfile, Direct ));
  Insert(FileView);
end;
{=======================================================================}
procedure TBtrFileW.SetCompatibleRect;
var R : TRect;
begin
 DeskTop^.GetExtent(R);
 if FileView^.Limit.Y < R.B.Y - HeadView^.Size.Y - 2 then begin
  with R do begin
   Assign(A.X,A.Y,B.X,A.Y+FileView^.Limit.Y+HeadView^.Size.Y+2);
  end;
 end;
 Locate(R);
 ReDraw;
end;
{=======================================================================}
procedure RegisterFBtrV;
begin
  RegisterType(RBtrFileVie);
  RegisterType(RBtrFileW);
end;

end.
