UNIT FONDVIEW;
{$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S+,T-,V-,X+,Y+}
INTERFACE

Uses BTRVVIEW, ANK1_GET, AN1_CONV, b_Interf, Drivers , LongView, Data_Lin,
     Pas_Dlg, NoFiDlg, Dialogs;

Function SearchName(p: Pointer) : Boolean; far;
Function Search_RN(p: Pointer) : Boolean;  far;
Function Search_NS(p: Pointer) : Boolean;  Far;
Function Search_SNS(p: Pointer) : Boolean; far;
Function Search_Pas(p: Pointer) : Boolean; far;

Type
   SearchFun = Function(p:Pointer):Boolean;
{Function SearchNil(p:Pointer):Boolean; far;}
Var
  SeFn : SearchFun;
  CmpStr : String;
  CmpRN  : LongInt;
  CmpNS  : LongInt;
  CmpSNS : NumSert_Get;
  CmpPas : PasspRec;
  SeFl   : Boolean;
Var
  VauFile : b_pFile;
  FalFile : b_pFile;
Const
   Head  : Array[0..3] of  THeadArray = (
   (
   ' ॣ. N                                 㬥     '+
   ' 䨪 泂',
   ''+
   'Ĵ',
   '','',''
   ),
   (
   '                            䨪 ॣ. N      㬥     '+
   ' 泂',
   ''+
   'Ĵ',
   '','',''
   ),
   (
   ' 䨪 ॣ. N                                 㬥     '+
   ' 泂',
   ''+
   'Ĵ',
   '','',''
   ),
   (
   '                ॣ. N                            '+
   ' 䨪Ⳃ',
   ''+
   'Ĵ',
   '','',''
   ));

Type
    pFondFileV = ^tFONDFileV;
    tFondFileV = object(tBTRFileV)
      CurrGetPrintLine : Pointer;
      Function   FormatRec(p : Pointer; ACaseForm : Word):String; virtual;
      Function   GetFocusedRelay: LongInt;
      Function   GetFocusedNVau: Byte;
      Function   GetPrintRelay: LongInt;
      Function   GetPrintNVau: Byte;
      Function   GetPrintLine(Var p : Pointer) : Word; Virtual;
      Function   GetVauch(Var FirstFlag : Boolean;
                          var V : NumVauch_Get) : Boolean;
      Function   GetPrintVauch(Var FirstFlag : Boolean;
                               var V : NumVauch_Get) : Boolean;
      Function   MakeVauStr(Var FirstFlag : Boolean;
                            N : Byte; var S : String) : Word;
      Function   EOFV : Boolean;  { ⮨   䠩}
      Function   NextPosInFile:LongInt; { ᫥饣 }
      Function   SearchInBuf( From : LongInt;
                              Var SearchPos : LongInt) : Boolean;
                   {TRUE -      - SearchPos}
      Function  SearchOk(p:Pointer;cmp:SearchFun): Boolean; virtual;

      Function  SearchInFile(To_Begin:Boolean
                             {TRUE -  砫 䠩/ ᫥饩  Current}
                                       ):Boolean;  { }

    End;

Type
    pFondFileW = ^tFONDFileW;
    tFondFileW = object(tBTRFileW)
      procedure HandleEvent(Var Event : TEvent); Virtual;
      procedure InsertBTRVViewer(
                     ABufferKBSize  : word;  {    }
                     AMaxWidth      : integer;
                     APfile         : b_PFile;
                     AHeadArray     : PHeadArray;
                     Direct         : Boolean ); virtual;
                     {冷 뢠}

    End;


IMPLEMENTATION

USES  Objects, App, Views, Str_Fun;


Function LiToSt(N : LongInt; Len : Byte) : String;
Var
  S : String;
Begin
  Str(N,S);
  LiToSt := Right(S,Len);
End;

Function VauStr(V:NumVauch_Get):String;
Begin
  VauStr := '  '+LitoSt(V.Ser,3)+':'+LiToSt(V.NN,8);
End;

Function sIDFK(p : Pointer) : String;              {9 -  }
Begin   With Client_Rec(p^) do With IDFK Do
  sIDFK := LiToSt(ID,8)+''
End;

Function sNAME(p : Pointer) : String;              {31 - }
Begin   With Client_Rec(p^) do With Ank Do
  sName := Left(FIO,30)+'';
End;

Function sPass(p : Pointer) : String;              {18 - ᯮ}
Const
  F1 = 8;   F2 = 2;  F3 = 6;
Begin   With Client_Rec(p^) do With Ank Do With Pas Do
  Case CaseFild of
    0: sPass := Right('',F1+1)+Left(RusSer,F2)+'#'+LiToSt(NN,F3)+'';
    1: sPass := Right(RimSer,F1)+'-'+Left(RusSer,F2)+'#'+LiToSt(NN,F3)+'';
    Else sPass:=Left('।⨥',F1+F2+F3+2)+'';
  End;
End;

Function sNV(p : Pointer) : String;                {3 - ⢮ ஢}
Begin  With Client_Rec(p^).Ank do
  sNV := LiToSt(N_Vauch,2)+'';
End;

Function sNA(p : Pointer) : String;                {5 - ⢮ }
Begin  With Client_Rec(p^).Ank do
  sNA := LiToSt(N_Akciy,4)+'';
End;

Function sNNS(p : Pointer) : String;               {12 - / }
Begin  With Client_Rec(p^).Ank.NumSert do
  sNNS := LiToSt(Ser,3)+':'+LiToSt(NN,7)+'';
End;

Function sAG(p : Pointer) : String;                {20 - }
Begin  With Client_Rec(p^) do
  sAG := Right(Agent,SizeOf(Agent)-1)+'';
End;


Function   tFondFileV.FormatRec(p : Pointer; ACaseForm : Word):String;
Begin
  Case ACaseForm Of
    0: FormatRec := sIDFK(p)+sName(p)+sPass(p)+sNNS(p)+sNA(p)+sNV(p);
    1: FormatRec := sName(p)+sNNS(p)+sIDFK(p)+sPass(p)+sNA(p)+sNV(p);
    2: FormatRec := sNNS(p)+sIDFK(p)+sName(p)+sPass(p)+sNA(p)+sNV(p);
    3: FormatRec := sAG(p)+sIDFK(p)+sName(p)+sNNS(p)+sNV(p);
  Else FormatRec := sIDFK(p)+sName(p)+sPass(p)+sNNS(p)+sNA(p)+sNV(p);
  End;
End;

Function   tFondFileV.GetFocusedRelay: LongInt;
Var
   P : Pointer;
Begin
   p := pRecordBox(FocusedInBuf)^.Body;
   GetFocusedRelay := Client_Rec(P^).IDFK.ID
End;

Function   tFondFileV.GetPrintRelay: LongInt;
Begin
  GetPrintRelay := Client_Rec(CurrGetPrintLine^).IDFK.ID
End;

Function   tFondFileV.GetPrintLine(Var p : Pointer) : Word;
Begin
  GetPrintLine := Inherited GetPrintLine(p);
  CurrGetPrintLine := p;
End;

Function   tFondFileV.GetPrintNVau: Byte;
Begin
  GetPrintNVau := Client_Rec(CurrGetPrintLine^).Ank.N_Vauch;
End;

Function   tFondFileV.GetFocusedNVau: Byte;
Var
   P : Pointer;
Begin
   p := pRecordBox(FocusedInBuf)^.Body;
   GetFocusedNVau := Client_Rec(P^).Ank.N_Vauch;
End;

Function   tFondFileV.MakeVauStr(Var FirstFlag : Boolean;
                                 N : Byte; var S : String) : Word;
Var
   j  : Byte;
   V  : NumVauch_Get;
   Fl : Boolean;
Begin
   MakeVauStr := 0;
   S := '            ';
   For J := 1 To N Do BEGIN
     Fl := GetPrintVauch(FirstFlag,V);
     If Fl = False Then begin
       MakeVauStr := 20;
       Exit;
     end;
     S := S + VauStr(V);
   END;
End;

Function tFondFileV.GetPrintVauch(Var FirstFlag : Boolean;
                                  var V : NumVauch_Get) : Boolean;
Var
  err     : b_Error;
  Rel_key : LongInt;
  RR      : Vau_bRec;
Begin
  Rel_Key := GetPrintRelay;
  If FirstFlag Then
    Begin
      VauFile^.Num_Key := 0;
      err := VauFile^.b_Get_Eq(Rel_Key,RR);
    End
  Else    Err := VauFile^.b_Get_Next(RR);
  FirstFlag := False;
  If Err <> Success Then GetPrintVauch := False
  Else
    Begin
      GetPrintVauch := True;
      V.Ser := RR.Ser;
      V.NN  := RR.NN;
    End;
End;

Function tFondFileV.GetVauch(Var FirstFlag : Boolean;
                             var V : NumVauch_Get) : Boolean;
Var
  err     : b_Error;
  Rel_key : LongInt;
  RR      : Vau_bRec;
Begin
  Rel_Key := GetFocusedRelay;
  If FirstFlag Then
    Begin
      VauFile^.Num_Key := 0;
      err := VauFile^.b_Get_Eq(Rel_Key,RR);
    End
  Else    Err := VauFile^.b_Get_Next(RR);
  FirstFlag := False;
  If Err <> Success Then GetVauch := False
  Else
    Begin
      GetVauch := True;
      V.Ser := RR.Ser;
      V.NN  := RR.NN;
    End;
End;

Function   tFondFileV.EOFV : Boolean;  { ⮨   䠩}
Begin
  With Browser Do EOFV := ((PosInFile+RecInBuf) >= Co_St);
End;

Function   tFondFileV.NextPosInFile:LongInt; { ᫥饣 }
Begin
  With Browser Do NextPosInFile := PosInFile+RecInBuf;
End;

Function   tFondFileV.SearchInBuf( From :Longint;
                                   Var SearchPos : LongInt) : Boolean;
Var
   l : LongInt;
Begin
  SearchPos := 0;
  SearchInBuf := False;
  For l := From To FileLines^.Count-1 Do
  If SearchOk(pRecordBox(FileLines^.At(L))^.Body,SeFn) Then
    Begin
      SearchInBuf := True;
      SearchPos := l;
      Exit;
    End;
End;

Function  tFondFileV.SearchOk(p:Pointer;cmp:SearchFun): Boolean;
Begin
  SearchOk := SeFn(p);
End;

Function  tFondFileV.SearchInFile(To_Begin:Boolean
                             {TRUE -  砫 䠩/ ᫥饩  Current}
                                       ):Boolean;  { }
Var
  From : Longint;
  Ok   : Boolean;
  SearchPos : LongInt;
  First     : Boolean;
  d         : pDialog;
  cur       : Longint;
  xxx       : longint;
Begin
  First := True;
  SearchInFile := False;
  If To_Begin Then
    Begin
      From := 0;
      {Browser.PosInFile := 0;}
      Delta.Y := 0;
      checkBufer;
      {ReadInBuffer(1); }
    End
  Else  From := FocusedAt-Browser.PosInFile;

  Ok := False;
  Repeat
    Ok := SearchInBuf(From,SearchPos);
    From := 0;
    IF EOFV Then Break;
    If Not Ok Then begin
        Delta.Y := Delta.Y+FileLines^.Count;
        If Delta.Y  > Limit.y-size.y then
           Delta.y := limit.y-size.y;
        CheckBufer;
        First:=False;
    End;
  Until OK;

  SearchInFile := Ok;

  If Ok Then
    Begin
      Delta.Y := SearchPos-5+Browser.PosInFile;
      if delta.y <= 0 then begin
          delta.y:=0;
          xxx:=SearchPos;
      end
      else   xxx:=delta.y+5;
      deltprev:=delta.y; {******}
      ScrollTo(Delta.X,Delta.Y);
      Cur := xxx-delta.y;
      SetCursor(0,cur);
    End
  Else
    Begin
      Delta.Y := 0;
      checkbufer;
      ScrollTo(Delta.X,Delta.Y);
      SetCursor(0,0);
      d := MakeNFDlg;
      DeskTop^.ExecView(d);
      Dispose(d,Done);
    End;
 DrawView;

End;

{========================================}
procedure tFondFileW.HandleEvent(Var Event : TEvent);
Const
   MaxCaseForm = 3;
Begin
  With Event Do if (What = evKeyBoard) then
    Case  KeyCode of
      kbGrayPlus :
        Begin
          If FileView^.CaseForm < MaxCaseForm Then
            Begin
              Inc(FileView^.CaseForm);
              InsertCurrentHead(@Head[FileView^.CaseForm]);
              ReDraw;
            End;
          ClearEvent(Event);
        End;
      kbGrayMinus:
        Begin
          If FileView^.CaseForm > 0 Then
            Begin
              Dec(FileView^.CaseForm);
              InsertCurrentHead(@Head[FileView^.CaseForm]);
              ReDraw;
            End;
          ClearEvent(Event);
        End;
    End; {CASE}
  Inherited HandleEvent(Event);
End;

procedure TFONDFileW.InsertBTRVViewer(
                     ABufferKBSize  : word;  {    }
                     AMaxWidth      : integer;
                     APfile         : b_PFile;
                     AHeadArray     : PHeadArray;
                     Direct         : Boolean );
                     {冷 뢠}
var
  R: TRect;
begin
  GetExtent(R);
  R.Grow(-1, -1);
  FileView := New(PFONDFileV, Init(R,
    StandardScrollBar(sbHorizontal + sbHandleKeyboard),
    StandardScrollBar(sbVertical + sbHandleKeyboard),
    ABufferKBSize, AMaxWidth, APfile, Direct ));
  Insert(FileView);
end;

Function SearchName(p: Pointer) : Boolean;
Begin
  With Client_Rec(p^).Ank do
  If Pos(ToRusBig(CmpStr),ToRusBig(Fio))=1 Then SearchName := True
  Else                                          SearchName := False;
End;

Function Search_RN(p: Pointer) : Boolean;
Begin
  With Client_Rec(p^).IDFK Do
  If (ID = CmpRN) Then Search_Rn := True
  Else               Search_Rn := False;
End;

Function Search_NS(p: Pointer) : Boolean;
Begin
  With Client_Rec(p^).Ank.NumSert Do
  If (NN = CmpNS) Then Search_NS := True
  Else                 Search_NS := False;
End;

Function Search_SNS(p: Pointer) : Boolean;
Begin
  With Client_Rec(p^).Ank.NumSert Do
  If (Ser = CmpSNS.Ser) And (NN = CmpSNS.NN) Then Search_SNS := True
  Else                                            Search_SNS := False;
End;

Function Search_Pas(p: Pointer) : Boolean;
Begin
  With Client_Rec(p^).Ank.Pas Do
  Case cmpPas.CaseFild of
    0: If (CaseFild=0) And (RusSer=CmpPas.RusSer)
                       And (NN = CmpPas.NN)       Then Search_Pas := True
       Else                                            Search_Pas := False;
    1: If (CaseFild=1) And (RusSer=CmpPas.RusSer)
                       And (RimSer=CmpPas.RimSer)
                       And (NN = cmpPas.NN)       Then Search_Pas := True
       Else                                            Search_Pas := False;
    2: If (CaseFild=2)  Then Search_Pas := True
       Else                  Search_Pas := False;
    Else  Search_Pas := True;
  End; {Case}
End;

Begin
  SeFn := SearchName;
  cmpStr :='';
  cmpRN  := 0;
  cmpNS  := 0;
  CmpSNS.Ser := 0;
  CmpSNS.NN  := 0;
  cmpPas.CaseFild := 0;
  cmpPas.RimSer   := '';
  cmpPas.RusSer   := '';
  cmpPas.NN       := 0;
  SeFl := True;
End.